<?php		
/*
 * @version $Id: mod_joomleague_next_match.php 1126 2008-06-09 05:45:04Z julienv $
 * @package Joomleague
 * @subpackage nextmatch
 * @copyright Copyright (C) 2007  JoomLeague
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see _joomleague_license.txt
**********************************************
JoomLeague Next-Match Module
Copyright (c) 2007 JoomLeague.de
**********************************************
This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This header must not be removed. Additional contributions/changes
may be added to this header as long as no information is deleted.
**********************************************

* NEXT MATCH MODULE
*
* 2008-01-08 - Version 0.93
*
* Module for displaying Next Match of the favoured
* JoomLeague Team in a selected Project 
* There are some options for this module, which can be set in the 
* "Parameters" section of the module in Administration.
*

**********************************************
Get the latest version of JoomLeague at:
http://http://www.joomleague.de//
**********************************************
*/
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_offset;

if (file_exists($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php')) {
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php');
} 
else{
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/english.php');
}

require_once ($mosConfig_absolute_path.'/administrator/components/com_joomleague/joomleague.class.php');

if (!function_exists('showGame')) {
	/**
   * return true if the game should be displayed according to limit per team
   *
   * @param int $homeId
   * @param int $awayId
   * @param int $limit
   * @param array $favTeams
   * @return boolean
   */
  function showGame( $homeId, $awayId, $limit = 0, $favTeams = array() ) 
  {
    static $teamshown = array();
    $showgame = 0 ;
    
    if ($limit == 0) return 1;      
    
    // init to prevent warnings
    if (!isset ($teamshown[$homeId])) $teamshown[$homeId]=0 ;
    if (!isset ($teamshown[$awayId])) $teamshown[$awayId]=0 ;
    
    if ( !count($favTeams) ) {//no favorite team
      if (  $teamshown[$homeId] < $limit 
         || $teamshown[$awayId] < $limit  ) $showgame = 1 ;
    }
    else if ( ( in_array( $homeId , $favTeams ) && $teamshown[$homeId] < $limit )
           || ( in_array( $awayId , $favTeams ) && $teamshown[$awayId] < $limit ) ) {
      $showgame = 1 ;
    }
    $teamshown[$homeId]++;
    $teamshown[$awayId]++;
    return $showgame;
  }
  
  /**
   * Create link to fireboard
   *
   * @param object $match
   * @return html
   */
  function make_fireboardlink(&$match)
  {
	  global $database;
	  static $sbItemid = 0; //doesn't change much from one call to he other...
	  
	  if ( $sbItemid == 0 ) { //this way, we only trig this request once
		  $database->setQuery("SELECT id FROM #__menu WHERE link='index.php?option=com_fireboard'");
		  $sbItemid = $database->loadResult();
	  }
	  $title = sprintf('%s - %s', addslashes($match->home_fullname), addslashes($match->away_fullname));
	
	  $query = sprintf("SELECT id FROM #__fb_messages WHERE catid =%s AND subject = '%s'",$match->sb_catid, $title);
	  $database->setQuery($query);
	  //print_r("<pre>".$database->getQuery()."</pre>");
	  $database->query();
	  $countPosts = $database->getNumRows();
	  $resultid = $database->loadResult();
	  
	  $title = sprintf('%s - %s',$match->home_fullname,$match->away_fullname);
	  if ($resultid == "")
    {
	    $showlink = ("index.php?option=com_fireboard&amp;Itemid=$sbItemid"
	    . "&amp;mid=" . $match->match_id
	    . "&amp;p=" . $match->project_id
	    . "&amp;func=post&amp;do=newFromJoomleague&amp;resubject=".strtr(base64_encode($title), "+/", "()")."&amp;catid=".$match->sb_catid
	    ."");
	    
	    return sprintf('<a href="%s">
        <img src="'.$mosConfig_absolute_path.'/components/com_joomleague/frontend/default'
	    .'/images/discuss.gif" border="0" alt="%s" title="%s" /></a>',$showlink,_JL_RESULTS_JOOMLABOARD_LINK,_JL_RESULTS_JOOMLABOARD_LINK);
	  }
	  else 
    {	
	    $showlink = sefRelToAbs("index.php?option=com_fireboard&amp;Itemid=" .$sbItemid. "&amp;func=view&amp;id=" .$resultid. "&amp;catid=" .$match->sb_catid. "");
	    
      return sprintf('<a href="%s"><img src="'.$mosConfig_absolute_path.'/components/com_joomleague/frontend/default'
      .'/images/discuss_active.gif" border="0" alt="%s %s" title="%s %s" /></a>',$showlink,$countPosts,_JL_RESULTS_JOOMLABOARD_COUNT,$countPosts,_JL_RESULTS_JOOMLABOARD_COUNT);
	  }
	}
	
	/**
	 * create link for team name
	 *
	 * @param string $team_name
	 * @param int $team_id
	 * @param int $project_id
	 * @param string $team_link_type
	 * @return html
	 */
	function make_teamlink($team_name, $team_id, $project_id, $team_link_type='')
  {
    $link = '';
    switch ($team_link_type) 
    {
      case '':
        return $team_name;
      case 'showPlan':
      case 'showPlan&mode=1':
      case 'showCurve':
      case 'showTeamInfo':
      case 'showPlayers':
        $link = '<a href="'.sefRelToAbs( 'index.php?option=com_joomleague&amp;func='.$team_link_type
                    . '&amp;p='.$project_id
                    . '&amp;tid='.$team_id )
                    . '">';
        $link .= $team_name;
        $link .= '</a>';
        return $link;      
      default :
        $link = '<a href="'.sefRelToAbs('index.php?option=com_joomleague&amp;func='.$team_link_type
                    . '&amp;p='.$project_id).'">';
        $link .= $team_name;
        $link .= '</a>';
        return $link;
    }
  }
}

// GET Parameters from backend settings
$p               = $params->def('project', 0); //default 0
$template        = $params->get('template');     // display type

$show_pics       = $params->get('show_picture'); //default 0
$show_link       = $params->get('show_link'); //default 0
$show_next_first = $params->get('show_next_first');
$show_playground = $params->get('show_playground');
$show_project    = $params->get('show_project');
$show_time       = $params->get('show_time');
$show_season_end_notice = $params->get('show_season_end_notice');
$show_fireboard_link = $params->get('show_fireboard_link');
$project_link = $params->get('project_link');
$team_link = $params->get('team_link');

$team            = $params->get('team');
$use_project_fav = $params->get('use_project_fav');

$name_type       = $params->get('names');
$logo_type       = $params->get('logo_type');
$playground_name = $params->get('playground_name');

// game selection
$rounds_span     = $params->get('rounds_span');
$days_span       = $params->get('days_span');
$number          = $params->get('number');
$game_per_team   = $params->get('game_per_team');
$delay           = $params->def('delay',0);

$season_end_notice = $params->get('season_end_notice');
// END of getting parameters

// load project
$project = new JoomLeague( $database );
$project->load($p);
$thistime=$project->getTimestamp('',1);

$favtemp = array();
if ($use_project_fav==1) 
{	
	// get favorote teams for each project
  $query = "SELECT fav_team FROM #__joomleague WHERE id IN ($p)";
  $database->setQuery($query);
  
  // put the teams ids in $favtemp array
  foreach ($database->loadResultArray() as $fav) {
  	if ( $fav != '' ) $favtemp = array_merge($favtemp, explode(",", $fav));
  }
  // generate list of favorite teams
  $favteam = implode(",", $favtemp);
}
else 
{
  $favteam = $team;
  if ( $favteam != '' ) {
	  $favtemp=explode(",", $favteam);
	}
}

$lastdate = '';
$lasttime = '';
$lastname = '';

$query = "SELECT m.match_date AS datum,
                 m.matchpart1 AS home,
                 m.matchpart2 AS away,
                 m.*,
                 r.matchcode, r.name as round,
                 t1.$name_type AS home_name,
                 t2.$name_type AS away_name,
                 c1.$logo_type AS home_logo,
                 c2.$logo_type AS away_logo,
                 j.name AS project_name";
                 
if ($show_fireboard_link) {
	$query .= ", j.enable_sb, j.sb_catid, 
              t1.name AS home_fullname, t2.name AS away_fullname";
}

if ($show_playground) {
	$query .= ", p.$playground_name AS playground";
}
  
$query .= " FROM #__joomleague_matches AS m
            INNER JOIN #__joomleague AS j ON m.project_id = j.id
            INNER JOIN #__joomleague_rounds AS r ON m.round_id = r.id
            INNER JOIN #__joomleague_teams AS t1 ON m.matchpart1 = t1.id
            INNER JOIN #__joomleague_teams AS t2 ON m.matchpart2 = t2.id
            LEFT JOIN #__joomleague_clubs AS c1 ON t1.club_id = c1.id
            LEFT JOIN #__joomleague_clubs AS c2 ON t2.club_id = c2.id";

if ($show_playground) {
  $query .= " LEFT JOIN #__joomleague_playgrounds AS p ON m.playground_id = p.id";
}

$query .= " WHERE m.project_id IN ($p)
            AND DATE_ADD(m.match_date, INTERVAL '".(-$delay)."' MINUTE) > '".date('Y-m-d H:i:s',$thistime)."'";

if ( count($favtemp) ) {
	$query .= " AND ( m.matchpart1 IN ($favteam) OR m.matchpart2 IN ($favteam))";
}
if ( $rounds_span != '' ) {
	$query .= " AND (r.matchcode - j.current_round <= $rounds_span)";
}
if ( $days_span != '' ) {
  $query .= " AND ('".date('Y-m-d H:i:s',$thistime)."' + INTERVAL '$days_span' DAY) >= m.match_date";
}
$query .= " ORDER by m.match_date, datum";
  
if (intval($number)) {
	$query .= " LIMIT 0, $number";
}
$database->setQuery($query);
if (!$matches = $database->loadObjectList()) echo $database->getErrorMsg();
//print_r("<pre>".$database->getQuery()."</pre>");
//print_r($matches);exit;

 //put a div id for easier css customisation
?>
<div id="modnextmatch">
<?php
  
$n = count($matches);
if ( $n > 0 ) 
{
  $i = 0;
  
  if ($template == 'template1')
	{
  foreach($matches as $match) 
  {
  	
	if ( showGame( $match->home, $match->away, $game_per_team , $favtemp ) ) 
	{
    if ($show_pics==1) 
    {  
  	  $matchpart1_pic = (trim($match->home_logo) != "")? sprintf('<img src="%s" alt="%s"/>', $match->home_logo, $match->home_name) : "";
  	  $matchpart2_pic = (trim($match->away_logo) != "")? sprintf('<img src="%s" alt="%s"/>', $match->away_logo, $match->away_name) : "";
	  }
    
		?>
			<table cellspacing="1" cellpadding="1" border="0" width="100%">
			<tr>
	      <td colspan="3" align="center">
	      <b><?php 
	      $date = mosFormatDate($match->datum, '%d%m%y',0);
	      $time = mosFormatDate($match->datum, '%H:%M',0);
	      if ($lastdate<>$date) {
	        echo mosFormatDate($match->datum,_JL_MODULE_NEXT_MATCH_DAYDATE,0)." ";
	        if ($show_time) echo mosFormatDate($match->datum,"%H:%M",0)."&nbsp;"._JL_CLOCK;
	      }
	      else if ( $show_time && $lasttime<>$time) 
	        echo mosFormatDate($match->datum,"%H:%M",0)."&nbsp;"._JL_CLOCK;
	      ?>
	      </b></td>
	    </tr>
	      <?php
	    if (($show_project == '1') && ($lastname<>$match->project_name)) {
	      ?>
	      <tr>
	        <td colspan="3" align="center"><b><?php echo $match->project_name;?></b></td>
	      </tr>
	      <?php
	    }
	      ?>
	    <tr>
	    	<td align="center" width="49%"><?php if ($show_pics==1) echo $matchpart1_pic."<br/>";
	    	echo $match->home_name;?></td>
	    	<td align="center">:</td>
	    	<td align="center" width="49%"><?php if ($show_pics==1) echo $matchpart2_pic."<br/>";
	    	echo $match->away_name;?></td>
	    </tr>
	    <?php
	      if ($show_playground) {
	      ?>
	      <tr>
	        <td colspan="3" align="center">
	        (<?php echo $match->playground; ?>)
	        </td>
	      </tr>
	      <?php
	      }
	    ?>
	</table>
	  <?php
	    if ($show_link==1) { ?>	
	    <center>
			<a href="<?php echo sefRelToAbs("index.php?option=com_joomleague&amp;func=showNextMatch&amp;p=$match->project_id&amp;mid=".$match->match_id."&amp;pics=$show_pics&amp;Itemid=$Itemid");?>"><?php echo _JL_MODULE_NEXT_MATCH_STATISTIC;?></a>
			</center>
	    <?php 
	    }
	  ?>
	
			<?php
		  if ($show_next_first==1) {
		    $roundsnext = '';
		    $query = "SELECT m.match_date AS datum,
		                         m.matchpart2_result AS away,
		                         m.matchpart1_result AS home,
		                         m.matchpart2 AS team_away,
		                         m.matchpart1 AS team_home,
		                         p.*
		                    FROM #__joomleague_matches m
		                    LEFT JOIN #__joomleague p ON m.project_id = p.id
		                   WHERE (( m.matchpart1 = $match->matchpart2 AND
		                         m.matchpart2 = $match->matchpart1) OR 
		                         ( m.matchpart1 = $match->matchpart1 AND
		                         m.matchpart2 = $match->matchpart2)) AND
		                         m.match_date < '".date('Y-m-d H:i:s',$thistime)."' ORDER by m.match_date DESC LIMIT 1";
	
			  $database->setQuery($query);
			  $database->loadObject( $roundsnext );
			  if ( $roundsnext && $roundsnext->datum != '0000-00-00 00:00:00' ) {
			    if ($match->matchpart1 == $roundsnext->team_home) {
		        $namehome = $match->home_name;
		        $nameaway = $match->away_name;
		      } else {
		        $namehome = $match->away_name;
		        $nameaway = $match->home_name;            
		      }
		      ?><center><?php echo _JL_MODULE_NEXT_MATCH_FIRST_MATCH;?>&nbsp;<?php echo mosFormatDate($roundsnext->datum,_JL_DAYDATE,0).'<br />'.$roundsnext->name;?><br /><?php echo "$namehome - $nameaway &nbsp;&nbsp;<b>".$roundsnext->home.":".$roundsnext->away."</b></center>";
			  }
		  }
		  
		  $lastname = $match->project_name;
		  $lastdate = mosFormatDate($match->datum, '%d%m%y', 0);
		  $lasttime = mosFormatDate($match->datum, '%H:%M', 0);
		  
	    if ( $i+1 < $n ) {
	      ?>
	      <hr align="center" width="95%" />
	      <?php
	    }
	    $i++;
    }
	  }	  
	}
	else if ($template == 'template2') {
    ?>
    <table width="96%" align="center" border="0" cellpadding="3" cellspacing="0">
    <?php
    $previous_date = '';
    
    $colspan = 4;
    if ($show_playground) $colspan++;
    if ($show_pics) $colspan+=2;
    if ($show_project) $colspan++;
    if ($show_time) $colspan++;
    
    foreach($matches as $match) {
    	if ( showGame( $match->home, $match->away, $game_per_team , $favtemp ) ) {
	    	$date = mosFormatDate($match->datum,"%d%m%y",0);
	      if ($date != $previous_date) {
		      ?>
		      <tr>
		            <td align="left" colspan="<?php echo $colspan; ?>" class="contentheading">
						      <?php
						      echo mosFormatDate($match->match_date, _JL_MATCHDAYDATE, 0)."\n";
						      ?>
		            </td>
		      </tr>
		      <?php
		      $previous_date = mosFormatDate($match->datum,"%d%m%y",0);
	      }
	      ?>
	      <tr class="sectiontableentry1" valign="middle">
	      <?php
	      if ($show_playground) {
	        echo '<td>';
	        echo $match->playground;
	        echo "</td>";
	      }
	      if ($show_time) {
		      echo '<td>';
		      echo substr( $match->match_date, 11, 5 );
		      echo '</td>';
	      }
		    if ($show_project) {
		    	echo '<td nowrap="nowrap">';
		    	if ( $project_link != '' ) {
  		    	echo '<a href="'.sefRelToAbs("index.php?option=com_joomleague&amp;func=$project_link&amp;p=$match->project_id&amp;r=$match->matchcode").'">';
  		      echo $match->project_name;
  		      echo '</a>';
		      }
		      else {
            echo $match->project_name;
          }
		      echo '</td>';
		    }
		    if ($show_pics) {
		      if ( $match->home_logo != "" ) {
            echo '<td style="vertical-align:middle; text-align:center;">';
            echo '<img src="'.$match->home_logo.'" style="max-width: 21px; height: auto;"/>';
            echo '</td>';
          }
          else {
            echo "<td>&nbsp;</td>";
          }
        }
	      echo '<td nowrap="nowrap">';
	      echo make_teamlink( $match->home_name, $match->matchpart1, $match->project_id, $team_link );
	      echo '</td>';
	      echo '<td nowrap="nowrap">-</td>';
        if ($show_pics) {
          if ( $match->away_logo != "" ) {
            echo '<td style="vertical-align:middle; text-align:center;">';
            echo '<img src="'.$match->away_logo.'" style="max-width: 21px; height: auto;"/>';
            echo '</td>';
          }
          else {
            echo "<td>&nbsp;</td>";
          }
        }
	      echo '<td nowrap="nowrap">';
	      echo make_teamlink( $match->away_name, $match->matchpart2, $match->project_id, $team_link );
	      echo "</td>";
	      if ( $match->enable_sb && $show_fireboard_link ) {
	        echo '<td>';
          echo make_fireboardlink($match);
          echo '</td>';
        }
	      ?>
	      </tr>
	      <?php
      }      
    }
    ?>
    </table>
    <?php
	 }
} 
else if ($show_season_end_notice){
  echo $season_end_notice;
}
?>
</div>
